-- MySQL Script generated by MySQL Workbench
-- Mon Jul 13 20:50:39 2020
-- Model: New Model    Version: 1.0
-- MySQL Workbench Forward Engineering

SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0;
SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0;
SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='ONLY_FULL_GROUP_BY,STRICT_TRANS_TABLES,NO_ZERO_IN_DATE,NO_ZERO_DATE,ERROR_FOR_DIVISION_BY_ZERO,NO_ENGINE_SUBSTITUTION';

-- -----------------------------------------------------
-- Schema Dictionary
-- -----------------------------------------------------

-- -----------------------------------------------------
-- Schema Dictionary
-- -----------------------------------------------------
CREATE SCHEMA IF NOT EXISTS `Dictionary` DEFAULT CHARACTER SET utf8 ;
USE `Dictionary` ;

-- -----------------------------------------------------
-- Table `Dictionary`.`Word`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `Dictionary`.`Word` (
  `idWord` INT NOT NULL AUTO_INCREMENT,
  `Word` VARCHAR(45) NULL,
  `fecha_de_registro` DATE NULL,
  PRIMARY KEY (`idWord`))
ENGINE = InnoDB;

CREATE UNIQUE INDEX `idPalabra_UNIQUE` ON `Dictionary`.`Word` (`idWord` ASC);


-- -----------------------------------------------------
-- Table `Dictionary`.`Definition`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `Dictionary`.`Definition` (
  `idDefinition` INT NOT NULL AUTO_INCREMENT,
  `Description` VARCHAR(300) NULL,
  `Source` VARCHAR(300) NULL,
  PRIMARY KEY (`idDefinition`))
ENGINE = InnoDB;

CREATE UNIQUE INDEX `idDefiniciones_UNIQUE` ON `Dictionary`.`Definition` (`idDefinition` ASC);


-- -----------------------------------------------------
-- Table `Dictionary`.`Translation`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `Dictionary`.`Translation` (
  `idTranslation` INT NOT NULL AUTO_INCREMENT,
  `Translation` VARCHAR(45) NULL,
  PRIMARY KEY (`idTranslation`))
ENGINE = InnoDB;

CREATE UNIQUE INDEX `idTranslation_UNIQUE` ON `Dictionary`.`Translation` (`idTranslation` ASC);


-- -----------------------------------------------------
-- Table `Dictionary`.`Type`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `Dictionary`.`Type` (
  `idType` INT NOT NULL AUTO_INCREMENT,
  `String` VARCHAR(45) NULL,
  PRIMARY KEY (`idType`))
ENGINE = InnoDB;

CREATE UNIQUE INDEX `idType_UNIQUE` ON `Dictionary`.`Type` (`idType` ASC);


-- -----------------------------------------------------
-- Table `Dictionary`.`Word_has_definition_type`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `Dictionary`.`Word_has_definition_type` (
  `Definition_idDefinition` INT NOT NULL,
  `Type_idType` INT NOT NULL,
  `Word_idWord` INT NOT NULL,
  PRIMARY KEY (`Definition_idDefinition`, `Type_idType`, `Word_idWord`),
  CONSTRAINT `fk_Word_has_definition_Definition1`
    FOREIGN KEY (`Definition_idDefinition`)
    REFERENCES `Dictionary`.`Definition` (`idDefinition`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT `fk_Word_has_definition_type_Type1`
    FOREIGN KEY (`Type_idType`)
    REFERENCES `Dictionary`.`Type` (`idType`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT `fk_Word_has_definition_type_Word1`
    FOREIGN KEY (`Word_idWord`)
    REFERENCES `Dictionary`.`Word` (`idWord`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB;

CREATE INDEX `fk_Word_has_definition_Definition1_idx` ON `Dictionary`.`Word_has_definition_type` (`Definition_idDefinition` ASC);

CREATE INDEX `fk_Word_has_definition_type_Type1_idx` ON `Dictionary`.`Word_has_definition_type` (`Type_idType` ASC);

CREATE INDEX `fk_Word_has_definition_type_Word1_idx` ON `Dictionary`.`Word_has_definition_type` (`Word_idWord` ASC);


-- -----------------------------------------------------
-- Table `Dictionary`.`Word_has_Synonym`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `Dictionary`.`Word_has_Synonym` (
  `Word_idWord` INT NOT NULL,
  `Word_idWordSynonym` INT NOT NULL,
  PRIMARY KEY (`Word_idWord`, `Word_idWordSynonym`),
  CONSTRAINT `fk_Word_has_Synonym_Word1`
    FOREIGN KEY (`Word_idWord`)
    REFERENCES `Dictionary`.`Word` (`idWord`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT `fk_Word_has_Synonym_Word2`
    FOREIGN KEY (`Word_idWordSynonym`)
    REFERENCES `Dictionary`.`Word` (`idWord`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB;

CREATE INDEX `fk_Word_has_Synonym_Word2_idx` ON `Dictionary`.`Word_has_Synonym` (`Word_idWordSynonym` ASC);


-- -----------------------------------------------------
-- Table `Dictionary`.`Word_has_translation`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `Dictionary`.`Word_has_translation` (
  `Translation_idTranslation` INT NOT NULL,
  `Word_idWord` INT NOT NULL,
  PRIMARY KEY (`Translation_idTranslation`, `Word_idWord`),
  CONSTRAINT `fk_Word_has_translation_Translation1`
    FOREIGN KEY (`Translation_idTranslation`)
    REFERENCES `Dictionary`.`Translation` (`idTranslation`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT `fk_Word_has_translation_Word1`
    FOREIGN KEY (`Word_idWord`)
    REFERENCES `Dictionary`.`Word` (`idWord`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB;

CREATE INDEX `fk_Word_has_translation_Translation1_idx` ON `Dictionary`.`Word_has_translation` (`Translation_idTranslation` ASC);

CREATE INDEX `fk_Word_has_translation_Word1_idx` ON `Dictionary`.`Word_has_translation` (`Word_idWord` ASC);


SET SQL_MODE=@OLD_SQL_MODE;
SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS;
SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS;
